最大单笔卖出利润
假设我们有一个由 n 个整数组成的数组,代表一天的股票价格。我们想要找到一对(buyDay, sellDay),其中buyDay ≤ sellDay,这样如果我们在buyDay买入股票并卖出它在sellDay,我们将最大化我们的利润。
显然,该算法有一个 O(n2) 解决方案,方法是尝试所有可能的 (buyDay, sellDay) 对并找出最好的他们所有人。然而,是否有更好的算法,也许是在 O(n) 时间内运行的算法?
Suppose we are given an array of n integers representing stock prices on a single day. We want to find a pair (buyDay, sellDay), with buyDay ≤ sellDay, such that if we bought the stock on buyDay and sold it on sellDay, we would maximize our profit.
Clearly there is an O(n2) solution to the algorithm by trying out all possible (buyDay, sellDay) pairs and taking the best out of all of them. However, is there a better algorithm, perhaps one that runs in O(n) time?
如果你对这篇内容有疑问,欢迎到本站社区发帖提问 参与讨论,获取更多帮助,或者扫码二维码加入 Web 技术交流群。
绑定邮箱获取回复消息
由于您还没有绑定你的真实邮箱,如果其他用户或者作者回复了您的评论,将不能在第一时间通知您!
发布评论
评论(20)
我喜欢这个问题。这是一个经典的面试问题,根据你如何思考,你最终会得到越来越好的解决方案。当然可以在比 O(n2) 更好的时间内完成此任务,并且我列出了三种不同的方式供您思考这个问题。
首先,分而治之的解决方案。让我们看看是否可以通过将输入分成两半,解决每个子数组中的问题,然后将两者组合在一起来解决这个问题。事实证明我们确实可以做到这一点,而且可以高效地做到这一点!直觉如下。如果我们只有一天,最好的选择是在那一天买入,然后在同一天卖回,没有利润。否则,将数组分成两半。如果我们考虑最佳答案可能是什么,它必须位于以下三个位置之一:
我们可以通过在前半部分和后半部分递归调用我们的算法来获得 (1) 和 (2) 的值。对于方案(3),获得最高利润的方法是在上半年的最低点买入,在下半年的最高点卖出。只需对输入进行简单的线性扫描并找到两个值,我们就可以找到两半中的最小值和最大值。然后,这为我们提供了具有以下递归式的算法:
使用主定理来解决递归,我们发现它运行在 O(n lg n) 时间内,并且将使用 O(lg n) 空间进行递归调用。我们刚刚击败了简单的 O(n2) 解决方案!
但是等等!我们可以做得比这更好。请注意,我们在递归中使用 O(n) 项的唯一原因是我们必须扫描整个输入,试图找到每一半中的最小值和最大值。由于我们已经递归地探索了每一半,也许我们可以通过让递归也返回存储在每一半中的最小值和最大值来做得更好!换句话说,我们的递归返回三件事:
最后两个值可以使用简单的递归来递归计算,我们可以在递归计算 (1) 的同时运行该递归:
如果我们使用这种方法,我们的递归关系现在是
使用主定理为我们提供了 O(n) 的运行时间和 O(lg n) 空间,这甚至比我们原来的解决方案更好!
但是等一下 - 我们可以做得更好!让我们考虑使用动态规划来解决这个问题。我们的想法是按如下方式思考这个问题。假设我们在查看前 k 个元素后就知道了问题的答案。我们能否利用我们对第 (k+1) 个元素的知识,结合我们的初始解决方案,来解决前 (k+1) 个元素的问题?如果是这样,我们可以通过解决第一个元素的问题,然后解决前两个,然后是前三个,等等,直到我们计算出前 n 个元素的问题来获得一个很好的算法。
让我们考虑一下如何做到这一点。如果我们只有一个元素,我们已经知道它一定是最佳的买入/卖出对。现在假设我们知道前 k 个元素的最佳答案,并查看第 (k+1) 个元素。那么,该值可以创建比前 k 个元素更好的解决方案的唯一方法是,前 k 个元素中最小的元素与该新元素之间的差异大于我们迄今为止计算的最大差异。因此,假设当我们遍历元素时,我们会跟踪两个值 - 迄今为止我们看到的最小值,以及仅使用前 k 个元素即可获得的最大利润。最初,我们到目前为止看到的最小值是第一个元素,最大利润为零。当我们看到一个新元素时,我们首先通过计算以迄今为止看到的最低价格购买并以当前价格出售可以赚多少钱来更新我们的最佳利润。如果这比我们迄今为止计算的最优值更好,那么我们将最优解更新为这个新的利润。接下来,我们将目前看到的最小元素更新为当前最小元素和新元素中的最小值。
由于在每个步骤中我们只执行 O(1) 工作,并且我们只访问 n 个元素中的每一个一次,因此需要 O(n) 时间才能完成!而且,它只使用O(1)辅助存储。这是我们迄今为止所取得的最好成果!
例如,根据您的输入,该算法的运行方式如下。数组每个值之间的数字对应于算法在该点保存的值。您实际上不会存储所有这些(这将占用 O(n) 内存!),但了解算法的演变很有帮助:
答案:(5, 10)
答案:(4, 12)
答案:(1, 5 )
我们现在可以做得更好吗?不幸的是,不是渐近意义上的。如果我们使用少于 O(n) 的时间,我们就无法查看大输入上的所有数字,因此不能保证我们不会错过最佳答案(我们可以将其“隐藏”在我们要查找的元素中)没看)。另外,我们不能使用小于 O(1) 的空间。可能会对隐藏在大 O 表示法中的常数因子进行一些优化,但除此之外,我们不能指望找到任何更好的选择。
总的来说,这意味着我们有以下算法:
编辑:如果您有兴趣,我已经编写了这四种算法的 Python 版本,以便您可以使用它们并判断它们的相对性能。这是代码:
I love this problem. It's a classic interview question and depending on how you think about it, you'll end up getting better and better solutions. It's certainly possible to do this in better than O(n2) time, and I've listed three different ways that you can think about the problem here.
First, the divide-and-conquer solution. Let's see if we can solve this by splitting the input in half, solving the problem in each subarray, then combining the two together. Turns out we actually can do this, and can do so efficiently! The intuition is as follows. If we have a single day, the best option is to buy on that day and then sell it back on the same day for no profit. Otherwise, split the array into two halves. If we think about what the optimal answer might be, it must be in one of three places:
We can get the values for (1) and (2) by recursively invoking our algorithm on the first and second halves. For option (3), the way to make the highest profit would be to buy at the lowest point in the first half and sell in the greatest point in the second half. We can find the minimum and maximum values in the two halves by just doing a simple linear scan over the input and finding the two values. This then gives us an algorithm with the following recurrence:
Using the Master Theorem to solve the recurrence, we find that this runs in O(n lg n) time and will use O(lg n) space for the recursive calls. We've just beaten the naive O(n2) solution!
But wait! We can do much better than this. Notice that the only reason we have an O(n) term in our recurrence is that we had to scan the entire input trying to find the minimum and maximum values in each half. Since we're already recursively exploring each half, perhaps we can do better by having the recursion also hand back the minimum and maximum values stored in each half! In other words, our recursion hands back three things:
These last two values can be computed recursively using a straightforward recursion that we can run at the same time as the recursion to compute (1):
If we use this approach, our recurrence relation is now
Using the Master Theorem here gives us a runtime of O(n) with O(lg n) space, which is even better than our original solution!
But wait a minute - we can do even better than this! Let's think about solving this problem using dynamic programming. The idea will be to think about the problem as follows. Suppose that we knew the answer to the problem after looking at the first k elements. Could we use our knowledge of the (k+1)st element, combined with our initial solution, to solve the problem for the first (k+1) elements? If so, we could get a great algorithm going by solving the problem for the first element, then the first two, then the first three, etc. until we'd computed it for the first n elements.
Let's think about how to do this. If we have just one element, we already know that it has to be the best buy/sell pair. Now suppose we know the best answer for the first k elements and look at the (k+1)st element. Then the only way that this value can create a solution better than what we had for the first k elements is if the difference between the smallest of the first k elements and that new element is bigger than the biggest difference we've computed so far. So suppose that as we're going across the elements, we keep track of two values - the minimum value we've seen so far, and the maximum profit we could make with just the first k elements. Initially, the minimum value we've seen so far is the first element, and the maximum profit is zero. When we see a new element, we first update our optimal profit by computing how much we'd make by buying at the lowest price seen so far and selling at the current price. If this is better than the optimal value we've computed so far, then we update the optimal solution to be this new profit. Next, we update the minimum element seen so far to be the minimum of the current smallest element and the new element.
Since at each step we do only O(1) work and we're visiting each of the n elements exactly once, this takes O(n) time to complete! Moreover, it only uses O(1) auxiliary storage. This is as good as we've gotten so far!
As an example, on your inputs, here's how this algorithm might run. The numbers in-between each of the values of the array correspond to the values held by the algorithm at that point. You wouldn't actually store all of these (it would take O(n) memory!), but it's helpful to see the algorithm evolve:
Answer: (5, 10)
Answer: (4, 12)
Answer: (1, 5)
Can we do better now? Unfortunately, not in an asymptotic sense. If we use less than O(n) time, we can't look at all the numbers on large inputs and thus can't guarantee that we won't miss the optimal answer (we could just "hide" it in the elements we didn't look at). Plus, we can't use any less than O(1) space. There might be some optimizations to the constant factors hidden in the big-O notation, but otherwise we can't expect to find any radically better options.
Overall, this means that we have the following algorithms:
EDIT: If you're interested, I've coded up a Python version of these four algorithms so that you can play around with them and judge their relative performances. Here's the code:
这是带有一点间接性的最大和子序列问题。最大和子序列问题给定一个可以是正数或负数的整数列表,找到该列表的连续子集的最大和。
您可以通过计算连续几天之间的利润或损失,轻松地将这个问题转换为另一个问题。因此,您可以将股票价格列表(例如
[5, 6, 7, 4, 2]
)转换为收益/损失列表,例如[1, 1, -3, -2]
。那么子序列和问题就很容易解决: 查找数组中元素和最大的子序列This is the maximum sum subsequence problem with a bit of indirection. The maximum sum subsequence problem is given a list of integers which could be positive or negative, find the largest sum of a contiguous subset of that list.
You can trivially convert this problem to that problem by taking the profit or loss between consecutive days. So you would transform a list of stock prices, e.g.
[5, 6, 7, 4, 2]
into a list of gains/losses, e.g.,[1, 1, -3, -2]
. The subsequence sum problem is then pretty easy to solve: Find the subsequence with largest sum of elements in an array我不太确定为什么这被认为是动态规划问题。我在教科书和算法指南中看到过这个问题,使用 O(n log n) 运行时间和 O(log n) 空间(例如《编程面试要素》)。这似乎是一个比人们想象的要简单得多的问题。
这是通过跟踪最大利润、最低购买价格以及最佳购买/出售价格来实现的。当它遍历数组中的每个元素时,它会检查给定元素是否小于最低购买价格。如果是,则最低购买价格指数 (
min
) 将更新为该元素的索引。此外,对于每个元素,becomeABillionaire
算法会检查arr[i] - arr[min]
(当前元素与最低购买价格之间的差值)是否大于当前利润。如果是,则利润将更新为该差额,并将买入设置为arr[min]
,将卖出设置为arr[i]
。单次运行。
合著者:https://stackoverflow.com/users/599402/ephraim
I'm not really sure why this is considered a dynamic programming question. I've seen this question in textbooks and algorithm guides using O(n log n) runtime and O(log n) for space (e.g. Elements of Programming Interviews). It seems like a much simpler problem than people are making it out to be.
This works by keeping track of the max profit, the minimum buying price, and consequently, the optimal buying/selling price. As it goes through each element in the array, it checks to see if the given element is smaller than the minimum buying price. If it is, the minimum buying price index, (
min
), is updated to be the index of that element. Additionally, for each element, thebecomeABillionaire
algorithm checks ifarr[i] - arr[min]
(the difference between the current element and the minimum buying price) is greater than the current profit. If it is, the profit is updated to that difference and buy is set toarr[min]
and sell is set toarr[i]
.Runs in a single pass.
Co-author: https://stackoverflow.com/users/599402/ephraim
该问题与最大子序列相同
我用动态规划解决了这个问题。跟踪当前和以前(利润、买入日期和卖出日期)
如果当前值高于先前值,则用当前值替换先前值。
The problem is identical to maximum sub-sequence
I solved it using Dynamic programming. Keep track of current and previous (Profit, buydate & sell date )
If current is higher than previous then replace the previous with current.
这是我的Java解决方案:
here is My Java solution :
我想出了一个简单的解决方案 - 代码更不言自明。这是动态规划问题之一。
该代码不考虑错误检查和边缘情况。它只是一个示例,给出解决问题的基本逻辑思路。
I have come up with a simple solution - code is more of Self-explanatory. It is one of those dynamic programming question.
The code doesn't take care of error checking and edge cases. Its just a sample to give the idea of basic logic to solve the problem.
这是我的解决方案。修改最大子序列算法。在 O(n) 内解决问题。我认为这不能做得更快了。
Here is my solution. modifies the maximum sub-sequence algorithm. Solves the problem in O(n). I think it cannot be done faster.
这是一个有趣的问题,因为它看起来很难,但仔细思考会产生一个优雅的、简化的解决方案。
正如已经指出的,它可以在 O(N^2) 时间内暴力破解。对于数组(或列表)中的每个条目,迭代所有先前的条目以获取最小值或最大值,具体取决于问题是找到最大收益还是最大损失。
以下是如何考虑 O(N) 的解决方案:每个条目代表一个新的可能的最大值(或最小值)。然后,我们需要做的就是保存先前的最小值(或最大值),并将差异与当前和先前的最小值(或最大值)进行比较。简单易行。
以下是 Java 中的 JUnit 测试代码:
在计算最大损失的情况下,我们跟踪列表中的最大值(买入价格)直至当前条目。然后我们计算最大值和当前条目之间的差异。如果最大-电流> maxLoss,然后我们将此差异保留为新的 maxLoss。由于 max 的索引保证小于 current 的索引,因此我们保证“买入”日期小于“卖出”日期。
在计算最大增益的情况下,一切都相反。我们跟踪列表中直到当前条目的最小值。我们计算最小值和当前条目之间的差异(反转减法中的顺序)。如果电流-最小值> maxGain,然后我们将这个差异保留为新的 maxGain。同样,“买入”(最小值)的索引位于当前(“卖出”)的索引之前。
我们只需要跟踪 maxGain(或 maxLoss)以及 min 或 max 的索引,但不需要同时跟踪两者,并且我们不需要比较索引来验证“买入”小于“卖出”,因为我们自然地得到这个。
This is an interesting problem, because it seems hard, but careful thought yields an elegant, pared-down solution.
As has been noted, it can be solved brute-force in O(N^2) time. For each entry in the array (or list), iterate over all previous entries to get the min or max depending on whether the problem is to find the greatest gain or loss.
Here's how to think about a solution in O(N): each entry represents a new possible max (or min). Then, all we need to do is save the prior min (or max), and compare the diff with the current and the prior min (or max). Easy peasy.
Here is the code, in Java as a JUnit test:
In the case of calculating the greatest loss, we keep track of the max in the list (buy price) up to the current entry. We then calculate the diff between the max and the current entry. If max - current > maxLoss, then we keep this diff as the new maxLoss. Since the index of max is guaranteed to be less than the index of current, we guarantee that the 'buy' date is less than the 'sell' date.
In the case of calculating the greatest gain, everything is reversed. We keep track of the min in the list up to the current entry. We calculate the diff between the min and the current entry (reversing the order in the subtraction). If current - min > maxGain, then we keep this diff as the new maxGain. Again, the index of the 'buy' (min) comes before the index of current ('sell').
We only need to keep track of the maxGain (or maxLoss), and the index of min or max, but not both, and we don't need to compare indices to validate that 'buy' is less than 'sell', since we get this naturally.
最大单次销售利润,O(n) 解决方案
这是一个项目,它对 100k 整数的随机数据集上的 o(N) 与 o(n^2) 方法进行时间复杂度测试。 O(n^2) 需要 2 秒,而 O(n) 需要 0.01 秒
https://github.com/gulakov/complexity.js
这是较慢的 o(n^2) 方法,每天循环遍历其余天,双循环。
Maximum single-sell profit, O(n) solution
Here's a project that does time complexity testing on o(N) vs o(n^2) approaches on a random data set on 100k ints. O(n^2) takes 2 seconds, while O(n) takes 0.01s
https://github.com/gulakov/complexity.js
This is the slower, o(n^2) approach that loops thru the rest of the days for each day, double loop.
得票最多的答案不允许最大利润为负的情况,应进行修改以允许此类情况。可以通过将循环范围限制为 (len(a) - 1) 并通过将指数移动 1 来改变确定利润的方式来实现此目的。
将此版本的函数与之前的数组进行比较:
The top voted answer does not allow for cases in which the maximum profit is negative and should be modified to allow for such cases. One can do so by limiting the range of the loop to (len(a) - 1) and changing the way profit is determined by shifting the index by one.
Compare this version of the function with the previous for the array:
确定最大利润的一种可能性可能是跟踪数组中每个索引处的左侧最小元素和右侧最大元素。然后,当您迭代股票价格时,对于任何给定的一天,您都会知道截至该天的最低价格,并且您还会知道该天之后(包括该天)的最高价格。
例如,让我们定义一个
min_arr
和max_arr
,给定的数组为arr
。min_arr
中的索引i
将是所有索引<= i
中arr
中的最小元素(和 的左侧)包括我)。max_arr
中的索引i
将是所有索引>= i
中arr
中的最大元素(和 的右侧)包括我)。然后,您可以找到 max_arr 和 min_arr 中相应元素之间的最大差异:这应该在 O(n) 时间内运行,但我相信它会占用大量空间。
A possibility to determine the maximum profit might be to keep track of the left-side minimum and right-side maximum elements in the array at each index in the array. When you are then iterating through the stock prices, for any given day you will know the lowest price up to that day, and you will also know the maximum price after (and including) that day.
For instance, let's define a
min_arr
andmax_arr
, with the given array beingarr
. Indexi
inmin_arr
would be the minimum element inarr
for all indices<= i
(left of and including i). Indexi
inmax_arr
would be the maximum element inarr
for all indices>= i
(right of and including i). Then, you could find the maximum difference between the corresponding elements inmax_arr
and `min_arr':This should run in O(n) time, but I believe it uses up a lot of space.
这是数组中两个元素之间的最大差异,这是我的解决方案:
O(N) 时间复杂度
O(1) 空间复杂度
This is maximum difference between two elements in array and this is my solution:
O(N) time complexity
O(1) space complexity
在 FB 解决方案工程师职位的现场编码考试中失败后,我必须在冷静的氛围中解决这个问题,所以这是我的 2 美分:
After failing this in a live coding exam for a FB solutions engineer position I had to solve it in a calm cool atmosphere, so here are my 2 cents:
真正回答问题的唯一答案是 @akash_magoon 的答案(并且以如此简单的方式!),但它不会返回问题中指定的确切对象。我重构了一点,并在 PHP 中得到了我的答案,返回了所要求的内容:
The only answer really answering the question is the one of @akash_magoon (and in such a simple way!), but it does not return the exact object specified in the question. I refactored a bit and have my answer in PHP returning just what is asked:
一个巧妙的解决方案:
A neat solution :
这个Python3程序可以返回使利润最大化的买入价和卖出价,计算的时间复杂度为O(n),空间复杂度为O(1)。
This program in python3 can return the buying price and selling price that will maximize the profit, computed with Time complexity of O(n) and Space complexity of O(1).
这是我的解决方案
Here's my solution
对于多次买入/卖出,
使用下面的代码
时间复杂度 O(n)
for multiple buy/sell,
Use the code below
Time Complexity O(n)
对于所有跟踪最小和最大元素的答案,该解决方案实际上是一个 O(n^2) 解决方案。这是因为最后必须检查最大值是否出现在最小值之后。如果没有,则需要进一步迭代,直到满足该条件,这会留下 O(n^2) 的最坏情况。如果您想跳过额外的迭代,则需要更多的空间。不管怎样,与动态规划解决方案相比,这是一个禁忌
For all the answers keeping track of the minimum and maximum elements, that solution is actually an O(n^2) solution. This is because at the end it must be checked whether the maximum occurred after the minimum or not. In case it didn't, further iterations are required until that condition is met, and this leaves a worst-case of O(n^2). And if you want to skip the extra iterations then a lot more space is required. Either way, a no-no as compared to the dynamic programming solution